package com.myoa.engineering.crawl.ppomppu.sender.dto;

import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonInclude;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

/**
 * MessageBlock
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-30
 *
 */
@Getter
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SlackMessageBlock implements Serializable {
    private static final long serialVersionUID = 1597984001727808419L;

    private SlackMessageBlockType type;
    private String text;

    @Builder
    private SlackMessageBlock(SlackMessageBlockType type, String text) {
        this.type = type;
        this.text = text;
    }

    public static SlackMessageBlock ofMarkDown(String message) {
        return SlackMessageBlock.builder()
                                .type(SlackMessageBlockType.MARKDOWN)
                                .text(message)
                                .build();
    }

    public static SlackMessageBlock ofDivider() {
        return SlackMessageBlock.builder()
                                .type(SlackMessageBlockType.DIVIDER)
                                .build();
    }

    public String getType() {
        return type.getType();
    }
}
